    PROGRAM nag_lin_lsq_ex07

      ! Example Program Text for nag_lin_lsq
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_in, nag_std_out
      USE nag_lin_lsq, ONLY : nag_qr_fac, nag_qr_orth, nag_lin_lsq_sol_qr
      USE nag_write_mat, ONLY : nag_write_gen_mat
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Intrinsic Functions ..
      INTRINSIC KIND, MIN
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)
      ! .. Local Scalars ..
      INTEGER :: i, m, n, ns
      REAL (wp) :: std_err
      ! .. Local Arrays ..
      INTEGER, ALLOCATABLE :: pivot(:)
      COMPLEX (wp), ALLOCATABLE :: a(:,:), b(:), q(:,:), tau(:), x(:)
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_lin_lsq_ex07'

      READ (nag_std_in,*)          ! Skip heading in data file
      READ (nag_std_in,*) m, n
      ns = MIN(m,n)

      ALLOCATE (pivot(n),a(m,n),b(m),q(m,MIN(m,n)),tau(ns), &
       x(n))                         ! Allocate storage

      READ (nag_std_in,*) (a(i,:),i=1,m)
      READ (nag_std_in,*) b

      ! Compute the QR factorization
      pivot = 0

      CALL nag_qr_fac(a,tau,pivot=pivot)

      ! Compute the transformation matrix Q

      CALL nag_qr_orth(a,tau,q=q)

      WRITE (nag_std_out,*)

      CALL nag_write_gen_mat(q,format='(F7.4)',title= &
       'Leading MIN(m,n) columns of Q')

      ! Compute the minimum norm solution

      CALL nag_lin_lsq_sol_qr(a,tau,b,x,pivot=pivot,std_err=std_err)

      WRITE (nag_std_out,*)
      WRITE (nag_std_out,*) 'Minimum norm solution'
      WRITE (nag_std_out,'(3X,''('',F7.4,'','',F7.4,'')'')') x
      WRITE (nag_std_out,*)
      WRITE (nag_std_out,'(1X,''Standard error '',F7.4)') std_err

      DEALLOCATE (pivot,a,b,q,tau,x) ! Deallocate storage

    END PROGRAM nag_lin_lsq_ex07
